using System;
using System.Collections.Generic;
using System.Runtime.Serialization;
using System.ServiceModel;

namespace UnifiedPOS.IndividualRecognition.V1_4
{
    [ServiceContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/")]
    public interface IndividualRecognition
    {
        #region Version 1.4

        //
        // Common Properties
        //

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/GetAutoDisable", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/GetAutoDisableResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/UposException", Name = "UposException")]
        bool GetAutoDisable(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/SetAutoDisable", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/SetAutoDisableResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/UposException", Name = "UposException")]
        void SetAutoDisable(string ConsumerID, bool AutoDisable);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/GetCapCompareFirmwareVersion", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/GetCapCompareFirmwareVersionResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/UposException", Name = "UposException")]
        bool GetCapCompareFirmwareVersion(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/GetCapPowerReporting", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/GetCapPowerReportingResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/UposException", Name = "UposException")]
        PowerReporting GetCapPowerReporting(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/GetCapStatisticsReporting", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/GetCapStatisticsReportingResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/UposException", Name = "UposException")]
        bool GetCapStatisticsReporting(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/GetCapUpdateFirmware", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/GetCapUpdateFirmwareResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/UposException", Name = "UposException")]
        bool GetCapUpdateFirmware(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/GetCapUpdateStatistics", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/GetCapUpdateStatisticsResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/UposException", Name = "UposException")]
        bool GetCapUpdateStatistics(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/GetCheckHealthText", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/GetCheckHealthTextResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/UposException", Name = "UposException")]
        string GetCheckHealthText(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/GetClaimed", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/GetClaimedResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/UposException", Name = "UposException")]
        bool GetClaimed(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/GetDataCount", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/GetDataCountResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/UposException", Name = "UposException")]
        int GetDataCount(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/GetDataEventEnabled", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/GetDataEventEnabledResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/UposException", Name = "UposException")]
        bool GetDataEventEnabled(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/SetDataEventEnabled", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/SetDataEventEnabledResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/UposException", Name = "UposException")]
        void SetDataEventEnabled(string ConsumerID, bool DataEventEnabled);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/GetDeviceEnabled", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/GetDeviceEnabledResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/UposException", Name = "UposException")]
        bool GetDeviceEnabled(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/SetDeviceEnabled", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/SetDeviceEnabledResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/UposException", Name = "UposException")]
        void SetDeviceEnabled(string ConsumerID, bool DeviceEnabled);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/GetFreezeEvents", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/GetFreezeEventsResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/UposException", Name = "UposException")]
        bool GetFreezeEvents(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/SetFreezeEvents", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/SetFreezeEventsResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/UposException", Name = "UposException")]
        void SetFreezeEvents(string ConsumerID, bool FreezeEvents);

        //[OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/GetOutputID", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/GetOutputIDResponse")]
        //[FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/UposException", Name = "UposException")]
        //int GetOutputID(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/GetPowerNotify", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/GetPowerNotifyResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/UposException", Name = "UposException")]
        PowerNotification GetPowerNotify(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/SetPowerNotify", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/SetPowerNotifyResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/UposException", Name = "UposException")]
        void SetPowerNotify(string ConsumerID, PowerNotification PowerNotify);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/GetPowerState", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/GetPowerStateResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/UposException", Name = "UposException")]
        PowerState GetPowerState(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/GetState", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/GetStateResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/UposException", Name = "UposException")]
        ControlState GetState(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/GetDeviceControlDescription", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/GetDeviceControlDescriptionResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/UposException", Name = "UposException")]
        string GetDeviceControlDescription(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/GetDeviceControlVersion", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/GetDeviceControlVersionResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/UposException", Name = "UposException")]
        UposVersion GetDeviceControlVersion(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/GetDeviceServiceDescription", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/GetDeviceServiceDescriptionResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/UposException", Name = "UposException")]
        string GetDeviceServiceDescription(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/GetDeviceServiceVersion", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/GetDeviceServiceVersionResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/UposException", Name = "UposException")]
        UposVersion GetDeviceServiceVersion(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/GetPhysicalDeviceDescription", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/GetPhysicalDeviceDescriptionResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/UposException", Name = "UposException")]
        string GetPhysicalDeviceDescription(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/GetPhysicalDeviceName", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/GetPhysicalDeviceNameResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/UposException", Name = "UposException")]
        string GetPhysicalDeviceName(string ConsumerID);

        //
        // Specific Properties
        //

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/GetCapIndividualList", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/GetCapIndividualListResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/UposException", Name = "UposException")]
        CapIndividualList GetCapIndividualList(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/GetIndividualIDs", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/GetIndividualIDsResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/UposException", Name = "UposException")]
        IndividualIDs GetIndividualIDs(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/GetIndividualRecognitionFilter", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/GetIndividualRecognitionFilterResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/UposException", Name = "UposException")]
        string GetIndividualRecognitionFilter(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/SetIndividualRecognitionFilter", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/SetIndividualRecognitionFilterResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/UposException", Name = "UposException")]
        void SetIndividualRecognitionFilter(string ConsumerID, string IndividualRecognitionFilter);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/GetIndividualRecognitionInformation", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/GetIndividualRecognitionInformationResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/UposException", Name = "UposException")]
        string GetIndividualRecognitionInformation(string ConsumerID);

        //
        // Common Methods
        //

        //[OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/Open", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/OpenResponse")]
        //[FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/UposException", Name = "UposException")]
        //void Open(string ConsumerID, string EndpointAddress);

        //[OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/Close", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/CloseResponse")]
        //[FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/UposException", Name = "UposException")]
        //void Close(string ConsumerID, string EndpointAddress);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/Claim", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/ClaimResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/UposException", Name = "UposException")]
        void Claim(string ConsumerID, int Timeout);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/Release", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/ReleaseResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/UposException", Name = "UposException")]
        void Release(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/CheckHealth", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/CheckHealthResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/UposException", Name = "UposException")]
        void CheckHealth(string ConsumerID, HealthCheckLevel Level);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/ClearInput", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/ClearInputResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/UposException", Name = "UposException")]
        void ClearInput(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/ClearInputProperties", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/ClearInputPropertiesResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/UposException", Name = "UposException")]
        void ClearInputProperties(string ConsumerID);

        //[OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/ClearOutput", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/ClearOutputResponse")]
        //[FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/UposException", Name = "UposException")]
        //void ClearOutput(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/DirectIO", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/DirectIOResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/UposException", Name = "UposException")]
        DirectIOData DirectIO(string ConsumerID, int Command, int Data, object Obj);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/CompareFirmwareVersion", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/CompareFirmwareVersionResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/UposException", Name = "UposException")]
        CompareFirmwareResult CompareFirmwareVersion(string ConsumerID, string FirmwareFileName);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/ResetStatistics", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/ResetStatisticsResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/UposException", Name = "UposException")]
        void ResetStatistics(string ConsumerID, StatisticList StatisticsBuffer);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/RetrieveStatistics", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/RetrieveStatisticsResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/UposException", Name = "UposException")]
        string RetrieveStatistics(string ConsumerID, StatisticList StatisticsBuffer);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/UpdateFirmware", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/UpdateFirmwareResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/UposException", Name = "UposException")]
        void UpdateFirmware(string ConsumerID, string FirmwareFileName);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/UpdateStatistics", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/UpdateStatisticsResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/UposException", Name = "UposException")]
        void UpdateStatistics(string ConsumerID, StatisticList StatisticsBuffer);

        //
        // Specific Methods
        //

        //
        // Session Management
        //

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/GetWSPOSVersion", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/GetWSPOSVersionResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/UposException", Name = "UposException")]
        UposVersion GetWSPOSVersion();

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/GenerateConsumerID", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/GenerateConsumerIDResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/UposException", Name = "UposException")]
        string GenerateConsumerID();

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/OpenSession", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/OpenSessionResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/UposException", Name = "UposException")]
        void OpenSession(string ConsumerID, string EndpointAddress);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/CloseSession", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/CloseSessionResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/UposException", Name = "UposException")]
        void CloseSession(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/GetProviderSessionTimeout", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/GetProviderSessionTimeoutResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/UposException", Name = "UposException")]
        int GetProviderSessionTimeout(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/KeepAlive", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/KeepAliveResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/UposException", Name = "UposException")]
        void KeepAlive(string ConsumerID);

        //
        // Device Control
        //

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/OpenDevice", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/OpenDeviceResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/UposException", Name = "UposException")]
        void OpenDevice(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/CloseDevice", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/CloseDeviceResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/UposException", Name = "UposException")]
        void CloseDevice(string ConsumerID);

        //
        // Event Polling
        //

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/PollForUPOSEvent", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/PollForUPOSEventResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/UposException", Name = "UposException")]
        IndividualRecognitionEvent PollForUPOSEvent(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/SetEventResponse", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/SetEventResponseResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/UposException", Name = "UposException")]
        void SetEventResponse(string ConsumerID, IndividualRecognitionEventResponse EventResponse);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/GetEncryptedClaimedConsumerID", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/GetEncryptedClaimedConsumerIDResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/UposException", Name = "UposException")]
        string GetEncryptedClaimedConsumerID();

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/SetEventRequestProperties", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/SetEventRequestPropertiesResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/UposException", Name = "UposException")]
        void SetEventRequestProperties(string ConsumerID, PropertyNameList list);

        #endregion Version 1.4
    }

    #region Version 1.4

    //
    // Common Data Types
    //

    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/")]
    public class DirectIOData
    {
        [DataMember]
        public int Data { get; set; }

        [DataMember]
        public object Obj { get; set; }
    }

    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/")]
    public class UposException
    {
        [DataMember]
        public ErrorCode ErrorCode { get; set; }

        [DataMember]
        public int ErrorCodeExtended { get; set; }
    }

    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/")]
    public class UposVersion
    {
        [DataMember]
        public int Major { get; set; }

        [DataMember]
        public int Minor { get; set; }

        [DataMember]
        public int Build { get; set; }
    }

    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/")]
    public class Statistic
    {
        [DataMember]
        public string Name { get; set; }

        [DataMember]
        public string Value { get; set; }
    }

    [CollectionDataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/", ItemName = "Statistic")]
    public class StatisticList : List<Statistic>
    {
    }

    //
    // Common Enumerations
    //

    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/")]
    public enum CompareFirmwareResult
    {
        [EnumMember]
        CFV_FIRMWARE_OLDER,

        [EnumMember]
        CFV_FIRMWARE_SAME,

        [EnumMember]
        CFV_FIRMWARE_NEWER,

        [EnumMember]
        CFV_FIRMWARE_DIFFERENT,

        [EnumMember]
        CFV_FIRMWARE_UNKNOWN,
    }

    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/")]
    public enum ControlState
    {
        [EnumMember]
        S_CLOSED,

        [EnumMember]
        S_IDLE,

        [EnumMember]
        S_BUSY,

        [EnumMember]
        S_ERROR,
    }

    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/")]
    public enum ErrorCode
    {
        [EnumMember]
        E_CLOSED,

        [EnumMember]
        E_CLAIMED,

        [EnumMember]
        E_NOTCLAIMED,

        [EnumMember]
        E_NOSERVICE,

        [EnumMember]
        E_DISABLED,

        [EnumMember]
        E_ILLEGAL,

        [EnumMember]
        E_NOHARDWARE,

        [EnumMember]
        E_OFFLINE,

        [EnumMember]
        E_NOEXIST,

        [EnumMember]
        E_EXISTS,

        [EnumMember]
        E_FAILURE,

        [EnumMember]
        E_TIMEOUT,

        [EnumMember]
        E_BUSY,

        [EnumMember]
        E_EXTENDED,

        [EnumMember]
        E_DEPRECATED,
    }

    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/")]
    public enum HealthCheckLevel
    {
        [EnumMember]
        CH_INTERNAL,

        [EnumMember]
        CH_EXTERNAL,

        [EnumMember]
        CH_INTERACTIVE,
    }

    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/")]
    public enum PowerNotification
    {
        [EnumMember]
        PN_DISABLED,

        [EnumMember]
        PN_ENABLED,
    }

    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/")]
    public enum PowerReporting
    {
        [EnumMember]
        PR_NONE,

        [EnumMember]
        PR_STANDARD,

        [EnumMember]
        PR_ADVANCED,
    }

    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/")]
    public enum PowerState
    {
        [EnumMember]
        PS_UNKNOWN,

        [EnumMember]
        PS_ONLINE,

        [EnumMember]
        PS_OFF,

        [EnumMember]
        PS_OFFLINE,

        [EnumMember]
        PS_OFF_OFFLINE,
    }

    /*
    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/")]
    public enum StatisticCategories
    {
        [EnumMember]
        All,
        [EnumMember]
        Manufacturer,
        [EnumMember]
        Upos,
    }
    */

    public class StatisticCategories
    {
        public const string All = "";
        public const string Manufacturer = "M_";
        public const string Upos = "U_";
    }

    //
    // Specific Data Types
    //

    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/")]
    public class IndividualIdName
    {
        [EnumMember]
        public string Id;

        [EnumMember]
        public string Name;
    }

    [CollectionDataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/", ItemName = "IndividualIdName")]
    public class CapIndividualList : List<IndividualIdName>
    {
    }

    [CollectionDataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/", ItemName = "IndividualID")]
    public class IndividualIDs : List<string>
    {
    }

    //
    // Specific Enumerations
    //

    //
    // Constants
    //

    public class ExtendedError
    {
        public const int EFIRMWARE_BAD_FILE = 281;
        public const int ESTATS_ERROR = 280;
        public const int ESTATS_DEPENDENCY = 282;
    }

    public class StatisticProperties
    {
        public const string CommunicationErrorCount = "CommunicationErrorCount";
        public const string DeviceCategory = "DeviceCategory";
        public const string FirmwareRevision = "FirmwareRevision";
        public const string HoursPoweredCount = "HoursPoweredCount";
        public const string InstallationDate = "InstallationDate";
        public const string Interface = "Interface";
        public const string ManufactureDate = "ManufactureDate";
        public const string ManufacturerName = "ManufacturerName";
        public const string MechanicalRevision = "MechanicalRevision";
        public const string ModelName = "ModelName";
        public const string SerialNumber = "SerialNumber";
        public const string UnifiedPOSVersion = "UnifiedPOSVersion";
    }

    public class Wait
    {
        public const int FOREVER = -1;
    }

    //
    // Event Polling
    //

    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/")]
    public class IndividualRecognitionEvent
    {
        [DataMember]
        public DataEvent DataEvent { get; set; }

        [DataMember]
        public DirectIOEvent DirectIOEvent { get; set; }

        [DataMember]
        public ErrorEvent ErrorEvent { get; set; }

        //[DataMember]
        //public OutputCompleteEvent OutputCompleteEvent { get; set; }
        [DataMember]
        public StatusUpdateEvent StatusUpdateEvent { get; set; }

        [DataMember]
        public DataContainedEvent DataContainedEvent { get; set; }
    }

    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/")]
    public class IndividualRecognitionEventResponse
    {
        [DataMember]
        public DataEventResponse DataEventResponse { get; set; }

        [DataMember]
        public DataContainedEventResponse DataContainedEventResponse { get; set; }

        [DataMember]
        public DirectIOEventResponse DirectIOEventResponse { get; set; }

        [DataMember]
        public ErrorEventResponse ErrorEventResponse { get; set; }

        //[DataMember]
        //public OutputCompleteEventResponse OutputCompleteEventResponse { get; set; }
        [DataMember]
        public StatusUpdateEventResponse StatusUpdateEventResponse { get; set; }
    }

    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/")]
    public class DataEvent
    {
        [DataMember]
        public string Source { get; set; }

        [DataMember]
        public int EventID { get; set; }

        [DataMember]
        public DateTime TimeStamp { get; set; }

        [DataMember]
        public int Status { get; set; }
    }

    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/")]
    public class DataEventResponse
    {
        [DataMember]
        public int EventID { get; set; }
    }

    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/")]
    public class DirectIOEvent
    {
        [DataMember]
        public string Source { get; set; }

        [DataMember]
        public int EventID { get; set; }

        [DataMember]
        public DateTime TimeStamp { get; set; }

        [DataMember]
        public int EventNumber { get; set; }

        [DataMember]
        public int Data { get; set; }

        [DataMember]
        public object Obj { get; set; }
    }

    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/")]
    public class DirectIOEventResponse
    {
        [DataMember]
        public int EventID { get; set; }

        [DataMember]
        public DirectIOData DirectIOData { get; set; }
    }

    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/")]
    public class ErrorEvent
    {
        [DataMember]
        public string Source { get; set; }

        [DataMember]
        public int EventID { get; set; }

        [DataMember]
        public DateTime TimeStamp { get; set; }

        [DataMember]
        public ErrorCode ErrorCode { get; set; }

        [DataMember]
        public int ErrorCodeExtended { get; set; }

        [DataMember]
        public ErrorLocus ErrorLocus { get; set; }

        [DataMember]
        public ErrorResponse ErrorResponse { get; set; }
    }

    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/")]
    public class ErrorEventResponse
    {
        [DataMember]
        public int EventID { get; set; }

        [DataMember]
        public ErrorResponse ErrorResponse { get; set; }
    }

    /*
    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/")]
    public class OutputCompleteEvent
    {
        [DataMember]
        public string Source { get; set; }
        [DataMember]
        public int EventID { get; set; }
        [DataMember]
        public DateTime TimeStamp { get; set; }
        [DataMember]
        public int OutputID { get; set; }
    }

    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/")]
    public class OutputCompleteEventResponse
    {
        [DataMember]
        public int EventID { get; set; }
    }
    */

    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/")]
    public class StatusUpdateEvent
    {
        [DataMember]
        public string Source { get; set; }

        [DataMember]
        public int EventID { get; set; }

        [DataMember]
        public DateTime TimeStamp { get; set; }

        [DataMember]
        public int Status { get; set; }
    }

    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/")]
    public class StatusUpdateEventResponse
    {
        [DataMember]
        public int EventID { get; set; }
    }

    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/")]
    public enum ErrorLocus
    {
        [EnumMember]
        EL_INPUT,

        [EnumMember]
        EL_INPUT_DATA,
    }

    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/")]
    public enum ErrorResponse
    {
        [EnumMember]
        ER_CLEAR,

        [EnumMember]
        ER_CONTINUEINPUT,
    }

    [CollectionDataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/", ItemName = "PropertyName")]
    public class PropertyNameList : List<string>
    {
    }

    [CollectionDataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/", ItemName = "Parameter")]
    public class ParameterList : Dictionary<string, object>
    {
    }

    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/")]
    public class DataContainedEvent
    {
        [DataMember]
        public string Source { get; set; }

        [DataMember]
        public int EventID { get; set; }

        [DataMember]
        public DateTime TimeStamp { get; set; }

        [DataMember]
        public int Status { get; set; }

        [DataMember]
        public ParameterList Parameters { get; set; }
    }

    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/")]
    public class DataContainedEventData
    {
        [DataMember]
        public int EventID { get; set; }

        [DataMember]
        public bool SetDataEventEnabled { get; set; }

        [DataMember]
        public bool CallClearInputProperties { get; set; }
    }

    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/IndividualRecognition/")]
    public class DataContainedEventResponse
    {
        [DataMember]
        public int EventID { get; set; }

        [DataMember]
        public bool SetDataEventEnabled { get; set; }

        [DataMember]
        public bool CallClearInputProperties { get; set; }
    }

    #endregion Version 1.4
}